unit dhtmledit;
//Note: Import Typelibrary--
// c:\program files\common files\microsoft shared\triedit\dhtmledit.ocx
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, StdCtrls, Menus, ToolWin, ComCtrls, DHTMLEDLib_TLB,activex,
  Buttons, ExtCtrls,MSHTML,comobj, OleServer, ImgList, ActnList,typinfo;

type
  TDHMLAction=(dNew,dOpen,dSave,dSaveAs,dPaste,dCopy,dCut,dUndo,dRedo,dFind,dSelectAll,
               dSnapToGrid,dUnderline,dItalic,dBold,dColor,dNumList,dBullet,
               dDecreaseIndent,dIncreaseIndent,dAlignLeft,dCenter,dAlignRight,
               dHR,dFontName,dFontSize,dFontStyle,dBorders,dDocumentDetails,
               dinsImage,dInsAnchor,dInsButton,dInsHTML,
               dInsertTable,dInsertRow,dInsertColumn,dInsertCell,dDeleteRows,
               dDeleteColumns,dDeleteCells,dMergeCells,dSplitCell,
               dabsPosition,dBringToFront,dSendToBack,dBringForward,dSendBack,
               dBringAboveText,dSendBelowText,dLockElement);

  TfmHTMLEdit = class(TForm)
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    DHTML: TDHTMLEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    mnew: TMenuItem;
    mOpen: TMenuItem;
    mSave: TMenuItem;
    mSaveAs: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Edit1: TMenuItem;
    mUndo: TMenuItem;
    mRedo: TMenuItem;
    N3: TMenuItem;
    mCut: TMenuItem;
    mCopy: TMenuItem;
    mPaste: TMenuItem;
    SelectAll1: TMenuItem;
    N4: TMenuItem;
    FindText1: TMenuItem;
    N5: TMenuItem;
    mSnapToGrid: TMenuItem;
    View1: TMenuItem;
    mDocumentDetails: TMenuItem;
    Insret1: TMenuItem;
    mInsimage: TMenuItem;
    mInsAnchor: TMenuItem;
    mInsButton: TMenuItem;
    mInsHTML: TMenuItem;
    able1: TMenuItem;
    mInsertTable: TMenuItem;
    N6: TMenuItem;
    mInsertRow: TMenuItem;
    mInsertColumn: TMenuItem;
    mInsertCell: TMenuItem;
    N7: TMenuItem;
    mDeleteRows: TMenuItem;
    mDeleteColumns: TMenuItem;
    mDeleteCells: TMenuItem;
    mMergeCells: TMenuItem;
    mSplitCell: TMenuItem;
    D2D1: TMenuItem;
    mabsPosition: TMenuItem;
    mBringToFront: TMenuItem;
    mSendToBack: TMenuItem;
    mBringForward: TMenuItem;
    mSendBack: TMenuItem;
    mBringAboveText: TMenuItem;
    mSendBelowText: TMenuItem;
    N8: TMenuItem;
    mLockElement: TMenuItem;
    mBorders: TMenuItem;
    pnlControl: TPanel;
    bNew: TSpeedButton;
    bOpen: TSpeedButton;
    bSave: TSpeedButton;
    bCut: TSpeedButton;
    bCopy: TSpeedButton;
    bPaste: TSpeedButton;
    bUndo: TSpeedButton;
    bRedo: TSpeedButton;
    bFind: TSpeedButton;
    bUnderline: TSpeedButton;
    bItalic: TSpeedButton;
    bBold: TSpeedButton;
    bColor: TSpeedButton;
    bNumList: TSpeedButton;
    bBullet: TSpeedButton;
    bDecreaseIndent: TSpeedButton;
    bIncreaseIndent: TSpeedButton;
    bAlignLeft: TSpeedButton;
    bCenter: TSpeedButton;
    bAlignRight: TSpeedButton;
    bHR: TSpeedButton;
    bInsImage: TSpeedButton;
    btnUser1: TSpeedButton;
    btnUser2: TSpeedButton;
    btnUser3: TSpeedButton;
    btnUser4: TSpeedButton;
    cFontName: TComboBox;
    cFontSize: TComboBox;
    cFontStyle: TComboBox;
    ColorDialog1: TColorDialog;
    procedure File1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure DHTMLContextMenuAction(Sender: TObject;itemIndex: Integer);
    procedure FormCreate(Sender: TObject);
    procedure DHTMLDocumentComplete(Sender: TObject);
    procedure DHTMLShowContextMenu(Sender: TObject; xPos, yPos: Integer);
    procedure DHTMLonclick(Sender: TObject);
    procedure DHTMLonkeyup(Sender: TObject);
    procedure DHTMLExec(Sender:TObject);
    procedure D2D1Click(Sender: TObject);
  private
    { Private declarations }
  public
    DocComplete:Boolean;
    function SaveChanges:word;
    function SaveDocument(promptUser:Boolean):Boolean;
    function GetTextAlignment: TAlignment;
    procedure SetTextAlignment(const Value: TAlignment);
    procedure GetStyles;
    procedure ToggleControl;
    function GetProperty(const Name: String): OLEVariant;
    procedure SetProperty(const Name: String; Value: OleVariant);
    { Public declarations }
  end;

var
  fmHTMLEdit: TfmHTMLEdit;
  vnull:Olevariant;

implementation

uses IeConst, SetSnap, GetHTMLSrc, TableParam;

{$R *.dfm}
function TfmHTMLEdit.SaveChanges:word;
begin
  if DHTML.IsDirty then begin
    Result:=MessageDlg('󤺮ew, O_xsܧ?',mtConfirmation,
                      [mbYes, mbNo,mbCancel], 0);
    if Result=mrYes then begin
      if length(DHTML.CurrentDocumentPath) > 0 then
        SaveDocument(false)
      else
        SaveDocument(True);
    end;
  end
  else
    Result:=mrYes;
end;

function TfmHTMLEdit.SaveDocument(promptUser: Boolean): Boolean;
var s:string;
    v:olevariant;
begin
//  DisableToolBar;
  Result:=True;
  try
    v:=DHTML.CurrentDocumentPath;
    if (not PromptUser) and (length(v) > 0) then
      DHTML.SaveDocument(v)
    else
      if SaveDialog1.Execute then begin
        v:=SaveDialog1.FileName;
        DHTML.SaveDocument(v);
      end;
  except
    Result:=False;
  end;
//    DHTMLEdit1.DOM.selection.createtextrange.Collapse--?
end;


procedure TfmHTMLEdit.File1Click(Sender: TObject);
begin
  if length(DHTML.CurrentDocumentPath) > 0 then
    msave.Enabled:=True
  else
    mSave.Enabled:=False;
end;

procedure TfmHTMLEdit.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TfmHTMLEdit.DHTMLContextMenuAction(Sender: TObject;
  itemIndex: Integer);
begin

end;
{
               Select Case itemIndex
    Case 0
        DHTMLEdit1.ExecCommand DECMD_CUT, OLECMDEXECOPT_DODEFAULT
    Case 1
        DHTMLEdit1.ExecCommand DECMD_COPY, OLECMDEXECOPT_DODEFAULT
    Case 2
        DHTMLEdit1.ExecCommand DECMD_PASTE, OLECMDEXECOPT_DODEFAULT
    Case 4
        DHTMLEdit1.ExecCommand DECMD_SELECTALL, OLECMDEXECOPT_DODEFAULT
    Case 6
        DHTMLEdit1.ExecCommand DECMD_FONT, OLECMDEXECOPT_PROMPTUSER
    End Select

    If ctxtIs2DCapable Then
        Select Case itemIndex
        Case ctxtStdItemCount + 2
            DHTMLEdit1.ExecCommand DECMD_MAKE_ABSOLUTE, OLECMDEXECOPT_DODEFAULT
        End Select
    End If
    
    If ctxtIsTable Then
        Select Case itemIndex
        Case ctxtStdItemCount + ctxt2DItemCount + 2
            DHTMLEdit1.ExecCommand DECMD_INSERTROW, OLECMDEXECOPT_DODEFAULT
        Case ctxtStdItemCount + ctxt2DItemCount + 3
            DHTMLEdit1.ExecCommand DECMD_INSERTCOL, OLECMDEXECOPT_DODEFAULT
        Case ctxtStdItemCount + ctxt2DItemCount + 5
            DHTMLEdit1.ExecCommand DECMD_DELETEROWS, OLECMDEXECOPT_DODEFAULT
        Case ctxtStdItemCount + ctxt2DItemCount + 6
            DHTMLEdit1.ExecCommand DECMD_DELETECOLS, OLECMDEXECOPT_DODEFAULT
        End Select
    End If
}


procedure TfmHTMLEdit.FormCreate(Sender: TObject);
var v:Variant;
begin
  DHTML.Align:=alClient;
  DocComplete:=False;
  cFontName.Items.Assign(Screen.Fonts);
//  DHTML.NewDocument;
end;

procedure TfmHTMLEdit.GetStyles;
var varRange : OleVariant;
   l, h, i : longint;
   f:OleVariant;
   BlockFmt:TDEGetBlockFmtNamesParam;
begin
  blockfmt:=TDEGetBlockFmtNamesParam.create(self);
  try
    f:=blockfmt.DefaultInterface;
    DHTML.ExecCommand(DECMD_GETBLOCKFMTNAMES,OLECMDEXECOPT_DODEFAULT,f);
    VarRange:=blockfmt.DefaultInterface.Get_Names;
    l := VarArrayLowBound(VarRange, 1);
    h := VarArrayHighBound(VarRange, 1);
    for i := l to h do
      cFontStyle.Items.Add(VarRange[i]);
  finally
    blockfmt.free;
  end;
end;

procedure TfmHTMLEdit.DHTMLDocumentComplete(Sender: TObject);
begin
  DocComplete:=True;
  GetStyles;
  ToggleControl;
  mBorders.Checked:=DHTML.ShowBorders;
  mDocumentDetails.Checked:=DHTML.ShowDetails;
end;

function TfmHTMLEdit.GetProperty(const Name: String): OLEVariant;
var
  V: OleVariant;
begin
  if not DocComplete then exit;
  V := DHTML.DOM.selection.createRange;
  Result := V.queryCommandValue(Name);
end;

procedure TfmHTMLEdit.SetProperty(const Name: String; Value: OleVariant);
var
  V: OleVariant;
  S: OleVariant;
begin
  if not DocComplete then exit;
  if GetProperty(Name) <> Value then begin
    V := DHTML.DOM.selection.createRange;
    S := Value;
    V.execCommand(Name , False, S);
    ToggleControl;
  end;
end;

function TfmHTMLEdit.GetTextAlignment: TAlignment;
begin
  if GetProperty('JustifyRight') then
    Result := taRightJustify
  else
  if GetProperty('JustifyCenter') then
    Result := taCenter
  else
    Result := taLeftJustify;
end;

procedure TfmHTMLEdit.SetTextAlignment(const Value: TAlignment);
begin
  case Value of
    taLeftJustify : SetProperty('JustifyLeft', True);
    taCenter : SetProperty('JustifyCenter', True);
    taRightJustify : SetProperty('JustifyRight', True);
  end;
end;

procedure TfmHTMLEdit.ToggleControl;
var
  TxtAlign:TAlignment;
  s:string;
begin
  if not DocComplete then exit;
  bCopy.Enabled:=((DHTML.QueryStatus(DECMD_COPY) and DECMDF_ENABLED) = DECMDF_ENABLED);
  bCut.Enabled:=(DHTML.QueryStatus(DECMD_CUT) and DECMDF_ENABLED) = DECMDF_ENABLED;
  bPaste.Enabled:=(DHTML.QueryStatus(DECMD_PASTE) and DECMDF_ENABLED) = DECMDF_ENABLED;
  mCopy.Enabled:=bCopy.Enabled;
  mCut.Enabled:=bCut.Enabled;
  mPaste.Enabled:=bPaste.Enabled;
  bundo.Enabled:=(DHTML.QueryStatus(DECMD_UNDO) and DECMDF_ENABLED) = DECMDF_ENABLED;
  mundo.Enabled:=bundo.Enabled;
  bredo.Enabled:=(DHTML.QueryStatus(DECMD_REDO) and DECMDF_ENABLED) = DECMDF_ENABLED;
  mredo.Enabled:=bredo.Enabled;
  bfind.Enabled:=(DHTML.QueryStatus(DECMD_FINDTEXT) and DECMDF_ENABLED) = DECMDF_ENABLED;

  bBold.Down := GetProperty('Bold');
  bItalic.Down := GetProperty('Italic');
  bUnderline.Down := GetProperty('Underline');
  bNumList.Enabled:=DHTML.QueryStatus(DECMD_ORDERLIST)<> DECMDF_DISABLED;
  bNumList.Down := DHTML.QueryStatus(DECMD_ORDERLIST)=DECMDF_LATCHED;
  bBullet.Enabled:=DHTML.QueryStatus(DECMD_UNORDERLIST )<> DECMDF_DISABLED;
  bBullet.Down := DHTML.QueryStatus(DECMD_UNORDERLIST )=DECMDF_LATCHED;
  bIncreaseIndent.Enabled:=(DHTML.QueryStatus(DECMD_INDENT)=DECMDF_ENABLED);
  bDecreaseIndent.Enabled:=(DHTML.QueryStatus(DECMD_OUTDENT)=DECMDF_ENABLED);
//Insert
  bInsImage.Enabled:=(DHTML.QueryStatus(DECMD_IMAGE)=DECMDF_ENABLED);
  mInsImage.Enabled:=bInsImage.Enabled;
  mInsAnchor.Enabled:=(DHTML.QueryStatus(DECMD_HYPERLINK)=DECMDF_ENABLED);
//if a control, table, ActiveX control is selected then disable it
  mInsButton.Enabled:=CompareText(DHTML.DOM.selection.type_,'Control')<>0;
  mInsHTML.Enabled := mInsButton.Enabled;
//Table
  mInsertTable.Enabled:=(DHTML.QueryStatus(DECMD_INSERTTABLE)=DECMDF_ENABLED);
  mInsertRow.Enabled:=(DHTML.QueryStatus(DECMD_INSERTROW)=DECMDF_ENABLED);
  mInsertColumn.Enabled:=(DHTML.QueryStatus(DECMD_INSERTCOL)=DECMDF_ENABLED);
  mInsertCell.Enabled:=(DHTML.QueryStatus(DECMD_INSERTCELL)=DECMDF_ENABLED);
  mDeleteRows.Enabled:=(DHTML.QueryStatus(DECMD_DELETEROWS)=DECMDF_ENABLED);
  mDeleteColumns.Enabled:=(DHTML.QueryStatus(DECMD_DELETECOLS)=DECMDF_ENABLED);
  mDeleteCells.Enabled:=(DHTML.QueryStatus(DECMD_DELETECELLS)=DECMDF_ENABLED);
  mMergeCells.Enabled:=(DHTML.QueryStatus(DECMD_MERGECELLS)=DECMDF_ENABLED);
  mSplitCell.Enabled:=(DHTML.QueryStatus(DECMD_SPLITCELL)=DECMDF_ENABLED);
//note: 2DǳƴButton, Gmenu onClickˬd

  TxtAlign := GetTextAlignment;
  bAlignLeft.Down := (txtAlign = taLeftJustify);
  bCenter.Down := (txtAlign = taCenter);
  bAlignRight.Down := (txtAlign = taRightJustify);
  cFontName.ItemIndex := cFontName.Items.IndexOf(GetProperty('FontName'));

  s:=GetProperty('FontSize');
  if cFontSize.Items.IndexOf(s) =-1 then
    cFontSize.Items.Add(s);
  cFontSize.ItemIndex := cFontSize.Items.IndexOf(s);
  s:=DHTML.ExecCommand(DECMD_GETBLOCKFMT,OLECMDEXECOPT_DODEFAULT);
  cFontStyle.ItemIndex := cFontStyle.Items.Indexof(s);
end;


procedure TfmHTMLEdit.DHTMLShowContextMenu(Sender: TObject; xPos,
  yPos: Integer);
var v1,v2:OleVariant;
  l:TStringlist;
  i,n:integer;
  s1,s2:string;
begin
  l:=TStringlist.create;  //ȮɫOsmenuitems
  try
//note:  0:unchecked;  1:checked;  2:Gray
    l.Add('Cut=0');
    l.Add('Copy=0');
    l.Add('Paste=0');
    l.Add('-=0');
    l.Add('Select All=0');
    l.Add('-=0');
    l.Add('Font...=0');
    if not bCut.Enabled then l.Values['Cut']:='2';
    if not bCopy.Enabled then l.Values['Copy']:='2';
    if not bPaste.Enabled then l.Values['Paste']:='2';
    if (DHTML.QueryStatus(DECMD_SELECTALL) and DECMDF_ENABLED) <> DECMDF_ENABLED Then
      l.Values['Select All']:='2';
    if (DHTML.QueryStatus(DECMD_FONT) and DECMDF_ENABLED) <> DECMDF_ENABLED Then
      l.Values['Font...']:='2';
    n:=l.Count;
    v1:= VarArrayCreate([0, n], varVariant);
    v2:= VarArrayCreate([0, n], varVariant);
    for i:=0 to l.count-1 do begin
      if l.Names[i]='-' then begin
        v1[i]:='';
        v2[i]:=0;
      end
      else begin
        v1[i]:=l.names[i];
        v2[i]:=strtoint(l.Values[l.names[i]]);
      end;
    end;
  finally
    l.free;
  end;
  DHTML.SetContextMenu(v1,v2);
{
    ctxtIs2DCapable = False
    ctxtIsAbsPos = False
    ctxtIsTable = False

    ' Determine if the selected element is 2D capable
    cmdState = DHTMLEdit1.QueryStatus(DECMD_MAKE_ABSOLUTE)
    If cmdState >= DECMDF_ENABLED Then
        ctxtIs2DCapable = True
    End If

    'Use DECMD_SEND_TO_BACK to determine if this element is abs positioned
    cmdState = DHTMLEdit1.QueryStatus(DECMD_SEND_TO_BACK)
    If cmdState >= DECMDF_ENABLED Then
        ctxtIsAbsPos = True
    End If

    'Use DECMD_INSERTROW to determine if this element is a table
    cmdState = DHTMLEdit1.QueryStatus(DECMD_INSERTROW)
    If cmdState >= DECMDF_ENABLED Then
        ctxtIsTable = True
    End If

    ctxtStdItemCount = 6

    If ctxtIs2DCapable Then
        ctxt2DItemCount = 2 '1 Item + 1 Separator
    Else
        ctxt2DItemCount = 0
    End If


    If ctxtIsTable Then
        ctxtTableItemCount = 6 '4 Items + 2 Separators
    Else
        ctxtTableItemCount = 0
    End If

    states(5) = Unchecked

    If ctxtIs2DCapable Then
        strings(ctxtStdItemCount + 1) = ""
        states(ctxtStdItemCount + 1) = Unchecked
        If ctxtIsAbsPos Then
            strings(ctxtStdItemCount + 2) = "Make 1D"
        Else
            strings(ctxtStdItemCount + 2) = "Make 2D"
        End If
        states(ctxtStdItemCount + 2) = Unchecked
    End If

    If ctxtIsTable Then
        strings(ctxtStdItemCount + ctxt2DItemCount + 1) = ""
        states(ctxtStdItemCount + ctxt2DItemCount + 1) = Unchecked
        strings(ctxtStdItemCount + ctxt2DItemCount + 2) = "Insert Row"
        states(ctxtStdItemCount + ctxt2DItemCount + 2) = Unchecked
        strings(ctxtStdItemCount + ctxt2DItemCount + 3) = "Insert Column"
        states(ctxtStdItemCount + ctxt2DItemCount + 3) = Unchecked
        strings(ctxtStdItemCount + ctxt2DItemCount + 4) = ""
        states(ctxtStdItemCount + ctxt2DItemCount + 4) = Unchecked
        strings(ctxtStdItemCount + ctxt2DItemCount + 5) = "Delete Row"
        states(ctxtStdItemCount + ctxt2DItemCount + 5) = Unchecked
        strings(ctxtStdItemCount + ctxt2DItemCount + 6) = "Delete Column"
        states(ctxtStdItemCount + ctxt2DItemCount + 6) = Unchecked

    End If

    DHTMLEdit1.SetContextMenu strings, states

}

end;

procedure TfmHTMLEdit.DHTMLonclick(Sender: TObject);
begin
  ToggleControl;
end;

procedure TfmHTMLEdit.DHTMLonkeyup(Sender: TObject);
begin
  ToggleControl;
end;

procedure TfmHTMLEdit.DHTMLExec(Sender: TObject);
var sname:string;
  act:TDHMLAction;
  v:olevariant;
  tblParam:TDEInsertTableParam;
begin
  if Sender is TComponent then begin
    sname:=TComponent(Sender).Name;
    delete(sname,1,1);
    act:=dNew;
    inc(act,GetENumValue(typeinfo(TDHMLAction),'d'+sname));
    case act of
      dNew:if not (SaveChanges = mrCancel) Then
             DHTML.NewDocument;
      dOpen:begin
             if not (SaveChanges = mrCancel) Then
               if OpenDialog1.Execute then begin
                 v:=OpenDialog1.filename;
                 DHTML.LoadDocument(v);
               end;
             end;
      dSave:    SaveDocument(False);
      dSaveAs:  SaveDocument(True);
      dPaste:   DHTML.ExecCommand( DECMD_PASTE, OLECMDEXECOPT_DODEFAULT);
      dCopy:    DHTML.ExecCommand(DECMD_COPY, OLECMDEXECOPT_DODEFAULT);
      dCut:     DHTML.ExecCommand(DECMD_CUT, OLECMDEXECOPT_DODEFAULT);
      dUndo:    DHTML.ExecCommand(DECMD_UNDO,OLECMDEXECOPT_DODEFAULT);
      dRedo:    DHTML.ExecCommand(DECMD_REDO,OLECMDEXECOPT_DODEFAULT);
      dUnderline:SetProperty('Underline',bBold.down);
      dItalic:   SetProperty('Italic',bBold.down);
      dBold:     SetProperty('Bold',bBold.down);
      dNumList:DHTML.ExecCommand(DECMD_ORDERLIST, OLECMDEXECOPT_DODEFAULT);
      dBullet:DHTML.ExecCommand(DECMD_UNORDERLIST,OLECMDEXECOPT_DODEFAULT);
      dAlignLeft: SetTextAlignment(taLeftJustify);
      dCenter:    SetTextAlignment(taCenter);
      dAlignRight:SetTextAlignment(taRightJustify);
      dFontName:  SetProperty('FontName', cFontName.Text);
      dFontSize:  SetProperty('FontSize', cFontSize.text);
      dFontStyle:begin
                   v:=cFontStyle.text;
                   DHTML.ExecCommand(DECMD_SETBLOCKFMT,OLECMDEXECOPT_DODEFAULT,v);
                 end;
      dDecreaseIndent:DHTML.ExecCommand(DECMD_OUTDENT,OLECMDEXECOPT_DODEFAULT);
      dIncreaseIndent:DHTML.ExecCommand(DECMD_INDENT,OLECMDEXECOPT_DODEFAULT);
      dColor: if colorDialog1.Execute then
                SetProperty('ForeColor', colorDialog1.color);
      dFind:     DHTML.ExecCommand(DECMD_FINDTEXT,OLECMDEXECOPT_DODEFAULT);
      dSelectAll:DHTML.ExecCommand(DECMD_SELECTALL,OLECMDEXECOPT_DODEFAULT);
      dHR:(DHTML.DOM as IOleCommandTarget).Exec(@CMDSETID_Forms3,
           IDM_HORIZONTALLINE,MSOCMDEXECOPT_PROMPTUSER,vnull,vnull);

      dInsImage: DHTML.ExecCommand(DECMD_IMAGE,OLECMDEXECOPT_PROMPTUSER);
      dInsAnchor:DHTML.ExecCommand(DECMD_HYPERLINK,OLECMDEXECOPT_PROMPTUSER);
      dInsButton:begin
                   v:=DHTML.DOM.selection.createRange;
                   v.pasteHTML('<BUTTON TITLE=Button>Button!</BUTTON>');
                 end;
      dInsHTML:  begin
                   v:=DHTML.DOM.selection.createRange;
                   v.pasteHTML(GetHTMLSource);
                 end;
      dSnapToGrid:SetSnapGrid(DHTML);
      dBorders: DHTML.ShowBorders:=not DHTML.ShowBorders;
      dDocumentDetails: DHTML.ShowDetails:=not DHTML.ShowDetails;
      dInsertTable:
        begin
          tblParam:=TDEInsertTableParam.Create(self);
          try
            tblParam.AutoConnect:=True;
            if GetTableParam(tblParam) then begin
              v:=tblParam.DefaultInterface;
              DHTML.ExecCommand(DECMD_INSERTTABLE,OLECMDEXECOPT_DODEFAULT,v);
            end;
          finally
            tblParam.Free;
          end;
        end;
      dInsertRow:DHTML.ExecCommand(DECMD_INSERTROW,OLECMDEXECOPT_DODEFAULT);
      dInsertColumn:DHTML.ExecCommand(DECMD_INSERTCOL,OLECMDEXECOPT_DODEFAULT);
      dInsertCell:DHTML.ExecCommand(DECMD_INSERTCELL,OLECMDEXECOPT_DODEFAULT);
      dDeleteRows:DHTML.ExecCommand(DECMD_DELETEROWS,OLECMDEXECOPT_DODEFAULT);
      dDeleteColumns:DHTML.ExecCommand(DECMD_DELETECOLS,OLECMDEXECOPT_DODEFAULT);
      dDeleteCells:DHTML.ExecCommand(DECMD_DELETECELLS,OLECMDEXECOPT_DODEFAULT);
      dMergeCells:DHTML.ExecCommand(DECMD_MERGECELLS,OLECMDEXECOPT_DODEFAULT);
      dSplitCell:DHTML.ExecCommand(DECMD_SPLITCELL,OLECMDEXECOPT_DODEFAULT);
//2D
      dabsPosition:DHTML.ExecCommand(DECMD_MAKE_ABSOLUTE,OLECMDEXECOPT_DODEFAULT);
      dBringToFront:DHTML.ExecCommand(DECMD_BRING_TO_FRONT,OLECMDEXECOPT_DODEFAULT);
      dSendToBack:DHTML.ExecCommand(DECMD_SEND_TO_BACK,OLECMDEXECOPT_DODEFAULT);
      dBringForward:DHTML.ExecCommand(DECMD_BRING_FORWARD,OLECMDEXECOPT_DODEFAULT);
      dSendBack:DHTML.ExecCommand(DECMD_SEND_BACKWARD,OLECMDEXECOPT_DODEFAULT);
      dBringAboveText:DHTML.ExecCommand(DECMD_BRING_ABOVE_TEXT,OLECMDEXECOPT_DODEFAULT);
      dSendBelowText:DHTML.ExecCommand(DECMD_SEND_BELOW_TEXT,OLECMDEXECOPT_DODEFAULT);
      dLockElement:DHTML.ExecCommand(DECMD_LOCK_ELEMENT,OLECMDEXECOPT_DODEFAULT);
    end;
  end;
end;

procedure TfmHTMLEdit.Edit1Click(Sender: TObject);
begin
  mSnapToGrid.Checked:=DHTML.SnapToGrid;
end;

procedure ToggleEnableAndInUsed(m:TMenuItem; status:word);
begin
  case status of
    DECMDF_LATCHED:begin
                     m.Enabled:=True;
                     m.checked:=True;
                   end;
    DECMDF_ENABLED:begin
                     m.Enabled:=True;
                     m.checked:=False;
                   end;
    else begin
      m.Enabled:=False;
      m.checked:=False;
    end;
  end;
end;

procedure TfmHTMLEdit.D2D1Click(Sender: TObject);
var Status:Word;
begin
//2D
  ToggleEnableAndInUsed(mabsPosition,DHTML.QueryStatus(DECMD_MAKE_ABSOLUTE));
  mBringToFront.Enabled:=(DHTML.QueryStatus(DECMD_BRING_TO_FRONT)=DECMDF_ENABLED);
  mSendToBack.Enabled:=(DHTML.QueryStatus(DECMD_SEND_TO_BACK)=DECMDF_ENABLED);
  mBringForward.Enabled:=(DHTML.QueryStatus(DECMD_BRING_FORWARD)=DECMDF_ENABLED);
  mSendBack.Enabled:=(DHTML.QueryStatus(DECMD_SEND_BACKWARD)=DECMDF_ENABLED);
  mBringAboveText.Enabled:=(DHTML.QueryStatus(DECMD_BRING_ABOVE_TEXT)=DECMDF_ENABLED);
  mSendBelowText.Enabled:=(DHTML.QueryStatus(DECMD_SEND_BELOW_TEXT)=DECMDF_ENABLED);
  ToggleEnableAndInUsed(mLockElement,DHTML.QueryStatus(DECMD_LOCK_ELEMENT));
end;

initialization
  OleInitialize(nil);
  vnull:=VarEmpty;
finalization
  OleUninitialize;

end.


